import 'dart:html';
import 'dart:js';
import 'package:polymer/polymer.dart';

final sharejs = context['sharejs'];

/**
 * A Polymer click counter element.
 */
@CustomTag('shared-textarea')
class SharedTextarea extends PolymerElement with ChangeNotifier  {
  @reflectable @published String get document => __$document; String __$document; @reflectable set document(String value) { __$document = notifyPropertyChange(#document, __$document, value); }

  JsObject socket;
  JsObject share;
  JsObject _document;

  SharedTextarea.created() : super.created() {
    socket = new JsObject(context['WebSocket'], ['ws://afternoon-gorge-3044.herokuapp.com']);
    share = new JsObject(sharejs['Connection'], [socket]);

    _document = share.callMethod('get', ['documents', document]);
    _document.callMethod('subscribe');
    _document.callMethod('whenReady', [() {
      if (_document['type'] == null) {
        _document.callMethod('create', ['text']);
      }

      TextAreaElement textarea = $['textarea'];
      _document.callMethod('attachTextarea', [textarea]);
    }]);
  }
}

